// Model with 16 periods (from 25 till 104)
// model with concave inactivity utility  (new formulation: + d_7/phi*i7^phi)
// FRENCH DATA
// Scenario: Dynamics from a historical perspective (variable beta's, from 1900 onwards)

// BASE SCENARIO I : Closed Economy
// CLOSED ECONOMY WITH PAYG AND ERP
// WITH BOTH DEMOGRAPHIC TRANSITION EFFECT
//          AND   LONGEVITY EFFECT

//  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//   !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!   PERFECT COMPETITION CASE   !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//   !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!                     WITH ERP                       !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

periods 90;

var  P0 P1 P2 P3 P4 P5 P6 P7 P8 P9 P10 P11 P12 P13 P14 P15 PTot
      N sleeping
      c0 c1 c2 c3 c4 c5 c6 c7 c8 c9 c10 c11 c12 c13 c14 c15
      s0 s1 s2 s3 s4 s5 s6 s7 s8 s9 s10 s11 s12 s13 s14
      w0 w1 w2 w3 w4 w5 w6 w7 wb rhou rhoe rhol R
      tauw tauc tauf g
      H K gdp gdp1 gdp2 FH ct st dl in
      tfp_stoch  DR PATot   wt
       i6 i7 lambda6 lambda7  de
       ;
//    welf_0 welf_1 welf_2 welf_3 welf_4 welf_5 welf_6 welf_7 welf_8 welf_9 
//    welf_10 welf_11 welf_12 welf_13 welf_14 welf_15
//    dWFN0 dWFN1 dWFN2 dWFN3 dWFN4 dWFN5 dWFN6 dWFN7 
//    dWHN0 dWHN1 dWHN2 dWHN3 dWHN4 dWHN5 dWHN6 dWHN7
//    Omega0 Omega1 Omega2 Omega3 Omega4 Omega5 Omega6 Omega7 Omega 
//     V M qq p vacost 
//     u0 u1 u2 u3 u4 u5 u6 u7   
//     n0 n1 n2 n3 n4 n5 n6 n7
//     ZARA hsr
//    wshare  pi  Q du SSDeficit  SAW
parameters 
           chi mbar nu beta 
           Du0 Du1 Du2 Du3 Du4 Du5 Du6 Du7 
           Dn0 Dn1 Dn2 Dn3 Dn4 Dn5 Dn6 Dn7 
           h0 h1 h2 h3 h4 h5 h6 h7
           TFP alpha a delt eta gam
           rhoub rhoeb rholb tauwb taucb taufb gb
           d_6 d_7 phi coef;                             

//Preferences
//.................................
   beta=0.8179;   
   Du0=0.0;
   Du1=Du0; 
   Du2=Du1; 
   Du3=Du2; 
   Du4=Du3; 
   Du5=Du4; 
   Du6=Du5;
   Du7=Du6;

   Dn0=0.25;
   Dn1=Dn0; 
   Dn2=Dn1; 
   Dn3=Dn2; 
   Dn4=Dn3; 
   Dn5=Dn4; 
   Dn6=Dn5;
   Dn7=Dn6;

   d_6 = 0.0310;                      
   d_7 = 0.0490;                      
   phi=0.2;

//Technology
//.................................
   TFP=20;
   gam=0.97^20;
   alpha=0.33;
   delt=0.3973;  
    h0=2.70;   h1=3.30;   h2=3.85;   h3=4.45;   h4=5.00;   h5=5.80;   h6=5.60;   h7=5.50;

//Matching Variables
//.................................
   chi=0.3324;    
   a=43.5; 
   mbar=0.90;  
   nu=0.5; 

//Wages, Transfers and Public Consumption
//.................................
   eta  =  0.50;
   rhoub=0.40; 
   rhoeb=0.50; 
   rholb=0.55;
   taucb=0.40;
   tauwb=0.15;
   taufb=0.35;
   gb=0.20;

coef=0.83;

varexo 
           beta1 beta2 beta3 beta4 beta5 beta6 beta7 beta8
           beta9 beta10 beta11 beta12 beta13 beta14 beta15
           xpop
           eps_y eps_lb eps_be eps_bu
           mig_0 mig_1 mig_2 mig_3 mig_4 mig_5 mig_6 mig_7 mig_8 mig_9 mig_10 mig_11 mig_12 mig_13 mig_14 mig_15
           ; 

// ********************** 
   model;
// ********************** 

// Labor Market Variables
// ----------------------- 

// Unemployment
// 1=n0+u0;
// 1=n1+u1;
// 1=n2+u2;
// 1=n3+u3;
// 1=n4+u4;
// 1=n5+u5;
// 1=n6+u6+i6;
// 1=n7+u7+i7;   
                            
// Inactvity Rates of "old workers" (55-59 and 60-64)
   i6=lambda6;
   i7=lambda6(-1)+lambda7*(1-lambda6(-1));

// Average Retiremant Age
// ZARA=lambda6*57+lambda7*(1-lambda6)*62+(1-lambda6)*(1-lambda7)*65;  
// Share of Adlut Workers in subgroup less than 55 years old
// SAW=(n3+n4+n5)/(n0+n1+n2+n3+n4+n5);
// Dependency Ratio
   DR=(P8+P9+P10+P11+P12+P13+P14+P15)/(P0+P1+P2+P3+P4+P5+P6+P7);

// Population per age category
   P0=xpop;
   P1=beta1(-1)*P0(-1) + mig_1/1000;
   P2=beta2(-1)*P1(-1) + mig_2/1000;
   P3=beta3(-1)*P2(-1) + mig_3/1000;
   P4=beta4(-1)*P3(-1) + mig_4/1000;
   P5=beta5(-1)*P4(-1) + mig_5/1000;
   P6=beta6(-1)*P5(-1) + mig_6/1000;
   P7=beta7(-1)*P6(-1) + mig_7/1000;
   P8=beta8(-1)*P7(-1) + mig_8/1000;
   P9=beta9(-1)*P8(-1) + mig_9/1000;
   P10=beta10(-1)*P9(-1) + mig_10/1000;
   P11=beta11(-1)*P10(-1) + mig_11/1000;
   P12=beta12(-1)*P11(-1) + mig_12/1000;
   P13=beta13(-1)*P12(-1) + mig_13/1000;
   P14=beta14(-1)*P13(-1) + mig_14/1000;
   P15=beta15(-1)*P14(-1) + mig_15/1000;
   PATot=P0+P1+P2+P3+P4+P5+P6+P7;
   PTot=P0+P1+P2+P3+P4+P5+P6+P7+P8+P9+P10+P11+P12+P13+P14+P15;

// Job Seekers
// Omega0=                                                 P0;
// Omega1=            ( 1             - (1-chi)*n0(-1) ) * P1;
// Omega2=            ( 1             - (1-chi)*n1(-1) ) * P2;
// Omega3=            ( 1             - (1-chi)*n2(-1) ) * P3;
// Omega4=            ( 1             - (1-chi)*n3(-1) ) * P4;
// Omega5=            ( 1             - (1-chi)*n4(-1) ) * P5;
// Omega6=(1-lambda6)*( 1             - (1-chi)*n5(-1) ) * P6;
// Omega7=(1-lambda7)*( 1-lambda6(-1) - (1-chi)*n6(-1) ) * P7;
// Omega = Omega0+Omega1+Omega2+Omega3+Omega4+Omega5+Omega6+Omega7; 
   
// Matching Process
//  M=mbar*V^(1-nu)*Omega^nu;
//  qq=M/V;
//  p=M/Omega;

// Employment
// n0=p;
// n1=(1-p)*(1-chi)*n0(-1)+p;
// n2=(1-p)*(1-chi)*n1(-1)+p;
// n3=(1-p)*(1-chi)*n2(-1)+p;
// n4=(1-p)*(1-chi)*n3(-1)+p;
// n5=(1-p)*(1-chi)*n4(-1)+p;
// n6=(1-lambda6)*((1-p)*(1-chi)*n5(-1)+p);
// n7=(1-lambda7)*((1-p)*(1-chi)*n6(-1)+p*(1-lambda6(-1)));

// N=n0*P0+n1*P1+n2*P2+n3*P3+n4*P4+n5*P5+n6*P6+n7*P7;
   N=P0+P1+P2+P3+P4+P5+(1-i6)*P6+(1-i7)*P7;

// Flow Budget Constraints (no bequests)
//------------------------------------------------
//                                    rhou*w0*u0              + (1-tauw)*w0*n0 = (1+tauc)*c0 + s0;  
//  R/beta1(-1)*s0(-1)+ rhou*w1*u1              + (1-tauw)*w1*n1 = (1+tauc)*c1 + s1;
//  R/beta2(-1)*s1(-1)+ rhou*w2*u2              + (1-tauw)*w2*n2 = (1+tauc)*c2 + s2;
//  R/beta3(-1)*s2(-1)+ rhou*w3*u3              + (1-tauw)*w3*n3 = (1+tauc)*c3 + s3;
//  R/beta4(-1)*s3(-1)+ rhou*w4*u4              + (1-tauw)*w4*n4 = (1+tauc)*c4 + s4;
//  R/beta5(-1)*s4(-1)+ rhou*w5*u5              + (1-tauw)*w5*n5 = (1+tauc)*c5 + s5;
//  R/beta6(-1)*s5(-1)+ rhou*w6*u6 + rhoe*w6*i6 + (1-tauw)*w6*n6 = (1+tauc)*c6 + s6;
//  R/beta7(-1)*s6(-1)+ rhou*w7*u7 + rhoe*w7*i7 + (1-tauw)*w7*n7 = (1+tauc)*c7 + s7;
                                                   (1-tauw)*w0 = (1+tauc)*c0 + s0;
    R/beta1(-1)^coef*s0(-1)              + (1-tauw)*w1 = (1+tauc)*c1 + s1;
    R/beta2(-1)^coef*s1(-1)           + (1-tauw)*w2 = (1+tauc)*c2 + s2;
    R/beta3(-1)^coef*s2(-1)             + (1-tauw)*w3 = (1+tauc)*c3 + s3;
    R/beta4(-1)^coef*s3(-1)              + (1-tauw)*w4 = (1+tauc)*c4 + s4;
    R/beta5(-1)^coef*s4(-1)              + (1-tauw)*w5 = (1+tauc)*c5 + s5;
    R/beta6(-1)^coef*s5(-1) + rhoe*w6*i6 + (1-tauw)*w6*(1-i6) = (1+tauc)*c6 + s6;
    R/beta7(-1)^coef*s6(-1) + rhoe*w7*i7 + (1-tauw)*w7*(1-i7) = (1+tauc)*c7 + s7;
    R/beta8(-1)^coef*s7(-1)             + rhol*wb                     = (1+tauc)*c8 + s8;
    R/beta9(-1)^coef*s8(-1)             + rhol*wb                     = (1+tauc)*c9 + s9;
    R/beta10(-1)^coef*s9(-1)            + rhol*wb                     = (1+tauc)*c10 + s10;
    R/beta11(-1)^coef*s10(-1)           + rhol*wb                     = (1+tauc)*c11 + s11;
    R/beta12(-1)^coef*s11(-1)           + rhol*wb                     = (1+tauc)*c12 + s12;
    R/beta13(-1)^coef*s12(-1)           + rhol*wb                     = (1+tauc)*c13 + s13;
    R/beta14(-1)^coef*s13(-1)           + rhol*wb                     = (1+tauc)*c14 + s14;
    R/beta15(-1)^coef*s14(-1)           + rhol*wb                     = (1+tauc)*c15;
 
// Reference Wage
//-----------------
   wb=(w4+w5+w6+w7)/4;    

// Euler Conditions
//-----------------

  1/(1+tauc)/c0  = beta1^(1-coef) *beta*R(+1)/(1+tauc(+1))/c1(+1);
  1/(1+tauc)/c1  = beta2^(1-coef) *beta*R(+1)/(1+tauc(+1))/c2(+1);
  1/(1+tauc)/c2  = beta3^(1-coef) *beta*R(+1)/(1+tauc(+1))/c3(+1);
  1/(1+tauc)/c3  = beta4^(1-coef) *beta*R(+1)/(1+tauc(+1))/c4(+1);
  1/(1+tauc)/c4  = beta5^(1-coef) *beta*R(+1)/(1+tauc(+1))/c5(+1);
  1/(1+tauc)/c5  = beta6^(1-coef) *beta*R(+1)/(1+tauc(+1))/c6(+1);
  1/(1+tauc)/c6  = beta7^(1-coef) *beta*R(+1)/(1+tauc(+1))/c7(+1);
  1/(1+tauc)/c7  = beta8^(1-coef) *beta*R(+1)/(1+tauc(+1))/c8(+1);
  1/(1+tauc)/c8  = beta9^(1-coef) *beta*R(+1)/(1+tauc(+1))/c9(+1);
  1/(1+tauc)/c9  = beta10^(1-coef)*beta*R(+1)/(1+tauc(+1))/c10(+1);
  1/(1+tauc)/c10 = beta11^(1-coef)*beta*R(+1)/(1+tauc(+1))/c11(+1);
  1/(1+tauc)/c11 = beta12^(1-coef)*beta*R(+1)/(1+tauc(+1))/c12(+1);     
  1/(1+tauc)/c12 = beta13^(1-coef)*beta*R(+1)/(1+tauc(+1))/c13(+1);      
  1/(1+tauc)/c13 = beta14^(1-coef)*beta*R(+1)/(1+tauc(+1))/c14(+1);     
  1/(1+tauc)/c14 = beta15^(1-coef)*beta*R(+1)/(1+tauc(+1))/c15(+1);     

// Optimal Participation Rates (Early Retirement)
// ----------------------------------------------
// Early retirement at 55
//........................
//  i6=0.00;
//// ((d_6*i6^(phi-1))+Du6 + (rhoe-rhou)*w6/(1+tauc)/c6)*(1-i6) + beta*beta7 * ((d_7*i7(+1)^(phi-1))+Du7+(rhoe(+1)-rhou(+1))*w7(+1)/(1+tauc(+1))/c7(+1)) * (1-i7(+1))
//// = ((1-tauw-rhou)*w6/(1+tauc)/c6 -(Dn6-Du6))*n6 + beta*beta7*((1-tauw(+1)-rhou(+1))*w7(+1)/(1+tauc(+1))/c7(+1)-(Dn7-Du7))*n7(+1);
//  i6=0.1545;
   ((d_6*i6^(phi-1))+Du6 + (rhoe-rhou)*w6/(1+tauc)/c6)*(1-i6) + beta*beta7 * ((d_7*i7(+1)^(phi-1))+Du7+(rhoe(+1)-rhou(+1))*w7(+1)/(1+tauc(+1))/c7(+1)) * (1-i7(+1))
     = ((1-tauw-rhou)*w6/(1+tauc)/c6 -(Dn6-Du6)) + beta*beta7*((1-tauw(+1)-rhou(+1))*w7(+1)/(1+tauc(+1))/c7(+1)-(Dn7-Du7));

// Early retirement at 60
//........................
//  i7=0.00;
////  ((d_7*i7^(phi-1))+Du7 + (rhoe-rhou)*w7/(1+tauc)/c7) *(1-i7) = ((1-tauw-rhou)*w7/(1+tauc)/c7  - (Dn7-Du7))*n7;  
//  i7=0.5015;
    ((d_7*i7^(phi-1))+Du7 + (rhoe-rhou)*w7/(1+tauc)/c7) *(1-i7) = ((1-tauw-rhou)*w7/(1+tauc)/c7  - (Dn7-Du7));  

// Household Surplus
//-------------------
// dWHN7 = w7*(1-tauw-rhou)/(1+tauc)-(Dn7-Du7)*c7;
// dWHN6 = w6*(1-tauw-rhou)/(1+tauc)-(Dn6-Du6)*c6 + beta*beta7*c6/c7(+1)*dWHN7(+1)*(1-p(+1))*(1-chi)*(1-lambda7(+1));       
// dWHN5 = w5*(1-tauw-rhou)/(1+tauc)-(Dn5-Du5)*c5 + beta*beta6*c5/c6(+1)*dWHN6(+1)*(1-p(+1))*(1-chi)*(1-lambda6(+1)); 
// dWHN4 = w4*(1-tauw-rhou)/(1+tauc)-(Dn4-Du4)*c4 + beta*beta5*c4/c5(+1)*dWHN5(+1)*(1-p(+1))*(1-chi);  
// dWHN3 = w3*(1-tauw-rhou)/(1+tauc)-(Dn3-Du3)*c3 + beta*beta4*c3/c4(+1)*dWHN4(+1)*(1-p(+1))*(1-chi);  
// dWHN2 = w2*(1-tauw-rhou)/(1+tauc)-(Dn2-Du2)*c2 + beta*beta3*c2/c3(+1)*dWHN3(+1)*(1-p(+1))*(1-chi);  
// dWHN1 = w1*(1-tauw-rhou)/(1+tauc)-(Dn1-Du1)*c1 + beta*beta2*c1/c2(+1)*dWHN2(+1)*(1-p(+1))*(1-chi);  
// dWHN0 = w0*(1-tauw-rhou)/(1+tauc)-(Dn0-Du0)*c0 + beta*beta1*c0/c1(+1)*dWHN1(+1)*(1-p(+1))*(1-chi);  

// Firm's Behavior
//------------------- 
// Human Capital
// H=h0*n0*P0+h1*n1*P1+h2*n2*P2+h3*n3*P3+h4*n4*P4+h5*n5*P5+h6*n6*P6+h7*n7*P7; 
   H=h0*P0+h1*P1+h2*P2+h3*P3+h4*P4+h5*P5+h6*(1-i6)*P6+h7*(1-i7)*P7; 
// Production Function
// gdp= tfp_stoch*TFP*H^(1-alpha)*K(-1)^alpha-a*V;
   gdp= tfp_stoch*TFP*H^(1-alpha)*K(-1)^alpha;
// wshare=(1+tauf)*(n0*w0*P0+n1*w1*P1+n2*w2*P2+n3*w3*P3+n4*w4*P4+n5*w5*P5+n6*w6*P6+n7*w7*P7)/gdp;
// pi = gdp - wshare*gdp - (R+delt-1)*K(-1); 
// Factor Demands    
   R+delt-1 = tfp_stoch*TFP*alpha*(H/K(-1))^(1-alpha);
   FH=tfp_stoch*TFP*(1-alpha)*(K(-1)/H)^alpha;

// productivity shocks
//------------------- 
   tfp_stoch=gam*tfp_stoch(-1)+(1-gam)*1+eps_y;  

// Firm's Surplus
// ---------------------
// dWFN7 = h7*FH-(1+tauf)*w7;
// dWFN6 = h6*FH-(1+tauf)*w6 + beta7/R(+1)*dWFN7(+1)*(1-chi)*(1-lambda7(+1));
// dWFN5 = h5*FH-(1+tauf)*w5 + beta6/R(+1)*dWFN6(+1)*(1-chi)*(1-lambda6(+1));
// dWFN4 = h4*FH-(1+tauf)*w4 + beta5/R(+1)*dWFN5(+1)*(1-chi);
// dWFN3 = h3*FH-(1+tauf)*w3 + beta4/R(+1)*dWFN4(+1)*(1-chi);
// dWFN2 = h2*FH-(1+tauf)*w2 + beta3/R(+1)*dWFN3(+1)*(1-chi);
// dWFN1 = h1*FH-(1+tauf)*w1 + beta2/R(+1)*dWFN2(+1)*(1-chi);
// dWFN0 = h0*FH-(1+tauf)*w0 + beta1/R(+1)*dWFN1(+1)*(1-chi);

// Free Entry Condition
// ---------------------
// a=qq/Omega*(Omega0*dWFN0+Omega1*dWFN1+Omega2*dWFN2+Omega3*dWFN3+Omega4*dWFN4+Omega5*dWFN5+Omega6*dWFN6+Omega7*dWFN7);

// Wage Determination (Rent Sharing)
// -----------------------------------
//  (1-eta)*dWHN0=eta*((1-tauw)/(1+tauf)/(1+tauc))*dWFN0;
//  (1-eta)*dWHN1=eta*((1-tauw)/(1+tauf)/(1+tauc))*dWFN1;
//  (1-eta)*dWHN2=eta*((1-tauw)/(1+tauf)/(1+tauc))*dWFN2;
//  (1-eta)*dWHN3=eta*((1-tauw)/(1+tauf)/(1+tauc))*dWFN3;
//  (1-eta)*dWHN4=eta*((1-tauw)/(1+tauf)/(1+tauc))*dWFN4;
//  (1-eta)*dWHN5=eta*((1-tauw)/(1+tauf)/(1+tauc))*dWFN5;
//  (1-eta)*dWHN6=eta*((1-tauw)/(1+tauf)/(1+tauc))*dWFN6;
//  (1-eta)*dWHN7=eta*((1-tauw)/(1+tauf)/(1+tauc))*dWFN7;

  (1+tauf)*w0= h0*FH;
  (1+tauf)*w1= h1*FH;
  (1+tauf)*w2= h2*FH;
  (1+tauf)*w3= h3*FH;
  (1+tauf)* w4= h4*FH;
  (1+tauf)*w5= h5*FH;
  (1+tauf)*w6= h6*FH;
  (1+tauf)*w7= h7*FH;

// Equilibrium Conditions
// ----------------------
   ct=c0*P0+c1*P1+c2*P2+c3*P3+c4*P4+c5*P5+c6*P6+c7*P7+c8*P8+c9*P9+c10*P10+c11*P11+c12*P12+c13*P13+c14*P14+c15*P15;
   st=s0*P0+s1*P1+s2*P2+s3*P3+s4*P4+s5*P5+s6*P6+s7*P7+s8*P8+s9*P9+s10*P10+s11*P11+s12*P12+s13*P13+s14*P14;
   K     =st;
// K+Q=st;

// Non-Arbitrage condition (physical capital-shares)
//------------------------------------------------------------
// Q(+1)+pi(+1)=R(+1)*Q;
// Government Budget Constraint (adjustment through consumption taxes)
// ----------------------------------------------------------------------------------------
// Tax Revenue
   tauw=tauwb;
   tauf=taufb;
// tauc=taucb;
// Adjusting tauf rather than tauc has little effects on costs of pensions in % of GDP; leads to a fall (rather than a rise) in wb;
// hence reduces pensions received (and simultaneously the consumption taxes paid) by retired workers
   in=(tauw+tauf)*wt;
   sleeping=R*(s0(-1)*P1*(beta1(-1)^(coef-1)-1)/beta1(-1)^coef+s1(-1)*P2*(beta2(-1)^(coef-1)-1)/beta2(-1)^coef+s2(-1)*P3*(beta3(-1)^(coef-1)-1)/beta3(-1)^coef+s3(-1)*P4*(beta4(-1)^(coef-1)-1)/beta4(-1)^coef+s4(-1)*P5*(beta5(-1)^(coef-1)-1)/beta5(-1)^coef+s5(-1)*P6*(beta6(-1)^(coef-1)-1)/beta6(-1)^coef+s6(-1)*P7*(beta7(-1)^(coef-1)-1)/beta7(-1)^coef+s7(-1)*P8*(beta8(-1)^(coef-1)-1)/beta8(-1)^coef+s8(-1)*P9*(beta9(-1)^(coef-1)-1)/beta9(-1)^coef+s9(-1)*P10*(beta10(-1)^(coef-1)-1)/beta10(-1)^coef+s10(-1)*P11*(beta11(-1)^(coef-1)-1)/beta11(-1)^coef+s11(-1)*P12*(beta12(-1)^(coef-1)-1)/beta12(-1)^coef+s12(-1)*P13*(beta13(-1)^(coef-1)-1)/beta13(-1)^coef+s13(-1)*P14*(beta14(-1)^(coef-1)-1)/beta14(-1)^coef+s14(-1)*P15*(beta15(-1)^(coef-1)-1)/beta15(-1)^coef);
 
// Expenditures
   g=gb;
   rhou=rhoub*eps_bu;
// du=rhou*(w0*u0*P0+w1*u1*P1+w2*u2*P2+w3*u3*P3+w4*u4*P4+w5*u5*P5+w6*u6*P6+w7*u7*P7);
   rhoe=rhoeb*eps_be;
   de=rhoe*(w6*i6*P6+w7*i7*P7);
   rhol=rholb*eps_lb;   
   dl=rhol*wb*(P8+P9+P10+P11+P12+P13+P14+P15);
// dl=rhol*114.2605*(P8+P9+P10+P11+P12+P13+P14+P15); 
//  114.2605 is the year 2000 value of wb
// assuming a flat (rather tan proportional) pension changes almost nothing

// Flow Budget Constraint   
// SSDeficit=(du+dl+de-in)/gdp;
// tauc*ct+in=g*gdp+du+de+dl;
   tauc*ct+in+sleeping=g*gdp      +de+dl;

// Accounting: checks
//-------------------------

   gdp1 = ct + K - (1-delt)*K(-1) + g * gdp;
   gdp2 = (1+tauf)*(w0*P0+w1*P1+w2*P2+w3*P3+w4*P4+w5*P5+w6*(1-i6)*P6+w7*(1-i7)*P7) + (R+delt-1)*K(-1);              
// gdp1 = ct + K - (1-delt)*K(-1) + Q - Q(-1) + g * gdp;
// gdp2 = (1+tauf)*(n0*w0*P0+n1*w1*P1+n2*w2*P2+n3*w3*P3+n4*w4*P4+n5*w5*P5+n6*w6*P6+n7*w7*P7) + (R+delt-1)*K(-1) + pi ;              
// vacost=a*V/gdp; 
// wt=(n0*w0*P0+n1*w1*P1+n2*w2*P2+n3*w3*P3+n4*w4*P4+n5*w5*P5+n6*w6*P6+n7*w7*P7);
   wt=(w0*P0+w1*P1+w2*P2+w3*P3+w4*P4+w5*P5+w6*(1-i6)*P6+w7*(1-i7)*P7);
// hsr=(du+de+dl+ (1-tauw)*wt+(R+delt-1)*st(-1)-(1+tauc)*ct)/(du+de+dl+ (1-tauw)*wt+(R+delt-1)*st(-1));
// hsr=(du+de+dl-tauw*wt-tauc*ct + wt + (R+delt-1)*st(-1) - ct)/(du+de+dl+ (1-tauw)*wt+(R+delt-1)*st(-1));
//         du+de+dl-tauw*wt-tauc*ct = -g*gdp + tauf*wt;
// hsr=((1+tauf)*wt + (R+delt-1)*st(-1) - ct - g*gdp)/(du+de+dl+ (1-tauw)*wt+(R+delt-1)*st(-1));
  
// welf_15= log(c15); 
// welf_14=log(c14)+beta*beta15*welf_15(+1);
// welf_13=log(c13)+beta*beta14*welf_14(+1);
// welf_12=log(c12)+beta*beta13*welf_13(+1);
// welf_11=log(c11)+beta*beta12*welf_12(+1);
// welf_10=log(c10)+beta*beta11*welf_11(+1);
// welf_9=log(c9)+beta*beta10*welf_10(+1);
// welf_8=log(c8)+beta*beta9*welf_9(+1);
// welf_7=log(c7) - Dn7*n7 + d_7/phi*i7^phi + beta*beta8*welf_8(+1);
// welf_6=log(c6) - Dn6*n6 + d_6/phi*i6^phi + beta*beta7*welf_7(+1);
// welf_5=log(c5) - Dn5*n5 + beta*beta6*welf_6(+1);
// welf_4=log(c4) - Dn4*n4 + beta*beta5*welf_5(+1);
// welf_3=log(c3) - Dn3*n3 + beta*beta4*welf_4(+1);
// welf_2=log(c2) - Dn2*n2 + beta*beta3*welf_3(+1); 
// welf_1=log(c1) - Dn1*n1 + beta*beta2*welf_2(+1);
// welf_0=log(c0) - Dn0*n0 + beta*beta1*welf_1(+1);  

 end;


 initval;

P0        		 =0.7143;
P1        		 =0.687585;
P2        		 =0.6596;
P3        		 =0.628467;
P4        		 =0.594216;
P5        		 =0.554938;
P6        		 =0.50738;
P7        		 =0.448118;
P8        		 =0.3727;
P9        		 =0.280009;
P10       		 =0.177638;
P11       		 =0.0863853;
P12       		 =0.0280148;
P13       		 =0.00563377;
P14       		 =0.000683376;
P15       		 =4.38044e-005;
PTot      		 =5.74571;
N         		 =4.76429;
sleeping  		 =21.346;
c0        		 =70.4225;
c1        		 =80.7327;
c2        		 =92.5045;
c3        		 =105.885;
c4        		 =121.061;
c5        		 =138.156;
c6        		 =157.164;
c7        		 =177.862;
c8        		 =199.48;
c9        		 =220.339;
c10       		 =237.283;
c11       		 =245.54;
c12       		 =239.103;
c13       		 =216.729;
c14       		 =182.103;
c15       		 =139.049;
s0        		 =1.03655;
s1        		 =7.56013;
s2        		 =19.6082;
s3        		 =39.632;
s4        		 =68.8922;
s5        		 =116.912;
s6        		 =167.371;
s7        		 =227.637;
s8        		 =196.583;
s9        		 =155.948;
s10       		 =111.064;
s11       		 =68.9533;
s12       		 =38.9156;
s13       		 =20.2752;
s14       		 =8.55403;
w0        		 =75.4509;
w1        		 =92.2178;
w2        		 =107.587;
w3        		 =124.354;
w4        		 =139.724;
w5        		 =162.08;
w6        		 =156.491;
w7        		 =153.696;
wb        		 =152.998;
rhou      		 =0.2;
rhoe      		 =0;
rhol      		 =0;
R         		 =1.40968;
tauw      		 =0.15;
tauc      		 =-0.104027;
tauf      		 =0.35;
g         		 =0.2;
H         		 =20.8617;
K         		 =480.354;
gdp       		 =1174.65;
gdp1      		 =1174.65;
gdp2      		 =1174.65;
FH        		 =37.7254;
ct        		 =748.878;
st        		 =480.354;
dl        		 =0;
in        		 =291.488;
tfp_stoch 		 =1;
DR        		 =0.19837;
PATot     		 =4.7946;
wt        		 =582.976;
i6        		 =0.0201592;
i7        		 =0.0448233;
lambda6   		 =0.0201592;
lambda7   		 =0.0251716;
de        		 =0;

// Initial  Values of exogenous variables
//***************************************
// Productivity Shock
    eps_y=0;

// Transfers
    eps_bu=0.5;
    eps_be=0.0;
    eps_lb=0.0;

// Cohort sizes
    xpop=0.7143;

// Migration Shocks: 1900 values
    mig_0 = 0.00 ; mig_1 = 0.00 ; mig_2 = 0.00 ; mig_3 = 0.00 ; mig_4 = 0.00 ; mig_5 = 0.00 ; mig_6 = 0.00 ; mig_7 = 0.00 ; mig_8 = 0.00 ; mig_9 = 0.00 ;  mig_10 = 0.00 ; mig_11 = 0.00 ; mig_12 = 0.00 ; mig_13 = 0.00 ; mig_14 = 0.00 ; mig_15 = 0.00 ;

// the beta's: 1900 values
    beta1 = 0.9626 ; beta2 = 0.9593 ; beta3 = 0.9528 ; beta4 = 0.9455 ; beta5 = 0.9339 ; beta6 = 0.9143 ; beta7 = 0.8832 ; beta8 = 0.8317 ; beta9 = 0.7513 ; beta10 = 0.6344 ; beta11 = 0.4863 ; beta12 = 0.3243 ; beta13 = 0.2011 ; beta14 = 0.1213 ; beta15 = 0.0641 ;

end;

 steady(solve_algo=0);
 yy_iss=oo_.steady_state;
 check;


//***************************************
// PERMANENT SHOCKS
//***************************************
    endval;

// Transfers
    eps_bu=1;
    eps_be=0.70;
    eps_lb=0.65;

// Cohort sizes
    xpop=0.934456;

// Migration Shocks: 2095 values
   mig_0 = 0.00 ; mig_1 = 23.88915 ; mig_2 = 19.11132 ; mig_3 = 7.16675 ; mig_4 = 0.00000 ; mig_5 = 0.00000 ; mig_6 = 0.00000 ; mig_7 = 0.00000 ; mig_8 = 0.00000 ; mig_9 = 0.00000 ; mig_10 = -23.88915 ; mig_11 = -35.83373 ; mig_12 = -43.00048 ; mig_13 = -43.00048 ; mig_14 = -23.88915 ; mig_15 = 0.00000 ;
 
// the beta's: 2095 values
   beta1 = 0.9997 ; beta2 = 0.9995 ; beta3 = 0.9991 ; beta4 = 0.9987 ; beta5 = 0.9980 ; beta6 = 0.9975 ; beta7 = 0.9958 ; beta8 = 0.9907 ; beta9 = 0.9863 ; beta10 = 0.9851 ; beta11 = 0.9776 ; beta12 = 0.9374 ; beta13 = 0.8040 ; beta14 = 0.5104 ; beta15 = 0.2291 ;

   end; 

   steady(solve_algo=0);
   check;
//***************************************

//***************************************
// TRANSITORY SHOCKS
//***************************************

   shocks;     

// var eps_lb;        
// periods   1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50;
// values 
// 0.50	 0.50	0.50	0.50	0.50	0.50	0.50	0.50	0.50	0.60	0.80	0.90	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00
// 1 1 1 1 1 1 1 1 1 1    1 1 1 1 1 ;
   var eps_lb;        
   periods   1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50;
   values 
   0.50	 0.50	0.50	0.50	0.50	0.50	0.50	0.50	0.50	0.60	
   0.80	 0.90	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00
   1.00  1.02   1.00    0.94    0.90    0.86    0.82    0.78    0.74	0.70
   0.69  0.68	0.67	0.66	0.65	0.65	0.65	0.65	0.65	0.65	
   0.65  0.65	0.65	0.65	0.65	0.65	0.65	0.65	0.65	0.65 
   ;
// Shift to Fully_Funded Pension Scheme after 2000
// var eps_lb;        
// periods   1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70;
// values 
// 0.50	 0.50	0.50	0.50	0.50	0.50	0.50	0.50	0.50	0.60	0.80	0.90	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	
// 1 0 0 0 0 0 0 0 0 0      0 0 0 0 0 0 0 0 0 0        0 0 0 0 0 0 0 0 0 0     0 0 0 0 0 0 0 0 0 0      0 0 0 0 0 0 0 0 0 0   ;

//  var eps_be;        
//  periods   1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70;
//  values 
//  0.00	0.00	0.00	0.00	0.00	0.00	0.00	0.00	0.00	0.00	0.00	0.00	0.20	0.40	0.60	0.80	0.90	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00
//  1 1 1 1 1 1 1 1 1 1     1 1 1 1 1 1 1 1 1 1     1 1 1 1 1 1 1 1 1 1 ;  
    var eps_be;        
    periods   1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70;
    values 
    0.00	0.00	0.00	0.00	0.00	0.00	0.00	0.00	0.00	0.00	0.00	0.00	0.20	0.40	0.60	0.80	0.90	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00
    1 1 1 1 1 1 1 1 1 1     1 1 1 1 1 1 1 1 1 1     1 1 1 1 1 1 1 1 1 1 ;

   var eps_bu;        
   periods   1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55;
   values 
   0.50	 0.50	0.50	0.50  0.50	 0.50	 0.50	0.50	0.50	0.55	0.60	0.65	0.70	0.75	0.85	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00	1.00
   1 1 1 1 1 1 1 1 1 1      1 1 1 1 1 ;

   var xpop;        
   periods   1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 
            21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40;
   values 
   0.714310, 0.740898, 0.733994, 0.731510, 0.658194, 0.746560, 0.831510, 0.798471, 0.756426, 0.415074, 
   0.788873, 0.763043, 0.771086, 0.728226, 0.697958, 0.992929, 1.019890, 1.011185, 1.028218, 1.022633, 
   1.000000, 0.898527, 0.952685, 0.944523, 0.908466, 0.913464, 0.964543, 0.955896, 0.945367, 0.938401, 
   0.931553, 0.936180, 0.948024, 0.951759, 0.947631, 0.942790, 0.934063, 0.934215, 0.934345, 0.934456
   ;   

 var mig_0;
   periods   1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40;
   values 
   0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00, 0.00
    ;
 var mig_1;
   periods   1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40;
   values 
   0.00000, -16.14539, 1.94184, 17.00287, 18.46191, 29.53963, 26.89163, 1.86068, 2.50166, -25.43135, 29.30647, 2.60156, 19.67144, 33.13281, 13.43582, 17.98662, 5.79975, 15.55543, 15.06200, 24.36272, -8.86672, 30.05108, 29.38526, 29.35057, 29.32114, 29.29313, 29.27948, 29.25538, 29.24980, 29.25015, 29.25220, 23.88915, 23.88915, 23.88915, 23.88915, 23.88915, 23.88915, 23.88915, 23.88915, 23.88915
  ;
 var mig_2;
   periods   1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40;
   values 
   0.00000, 14.31414, 12.40041, 16.96258, 26.69506, 28.05035, 14.69069, -1.48718, -5.01604, -34.31651, 42.16739, 2.50333, 15.13016, 30.02349, 10.46457, 7.07707, -1.11978, 2.09762, 5.46851, 12.86019, 0.29600, 27.71947, 18.77945, 19.06172, 18.93397, 18.88549, 18.84176, 18.81935, 18.76088, 18.75442, 18.75918, 19.11132, 19.11132, 19.11132, 19.11132, 19.11132, 19.11132, 19.11132, 19.11132, 19.11132
    ;
 var mig_3;
   periods   1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40;
   values 
   0.00000, -7.47781, -7.27342, -2.31898, 26.25549, 9.10441, 4.65215, -6.56680, -23.27099, -41.05202, 39.44667, 1.68102, 9.20787, 21.55793, 7.78445, 4.00524, -0.91962, -0.40612, 0.95452, 5.45402, -1.27575, 9.25727, 8.68425, 8.47686, 8.35929, 8.10451, 8.00357, 7.92571, 7.86739, 7.72450, 7.70044, 7.16675, 7.16675, 7.16675, 7.16675, 7.16675, 7.16675, 7.16675, 7.16675, 7.16675
    ;
 var mig_4;
   periods   1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40;
   values 
   0.00000, 2.84905, 2.74169, -1.98664, 33.71415, 4.51108, 1.54876, -6.60575, -4.25486, -23.21978, 35.43847, -0.46518, 8.47050, 13.28636, 2.81921, 0.99874, -5.77511, -3.42694, -2.36281, 0.86871, -6.20834, 3.50195, 2.44211, 2.03424, 1.65323, 1.66750, 1.28312, 1.19930, 1.16904, 1.12081, 0.91162, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000
    ;
 var mig_5;
   periods   1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40;
   values 
   0.00000, -4.38729, -5.14654, -1.09658, 16.62970, -1.13545, -1.80295, -4.87335, -2.34884, -37.04372, 27.98736, -1.76400, 2.91180, 13.77953, 0.71602, -0.08682, -4.58182, -3.92440, -3.48073, 0.96596, 28.82449, 6.49336, 0.02786, -0.26815, -0.51610, -0.75116, -0.44903, -0.75580, -0.69618, -0.56033, -0.50737, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000
    ;
 var mig_6;
   periods   1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40;
   values 
   0.00000, -6.74305, -1.77198, -10.93911, 16.82944, -1.64888, -0.81491, -4.58490, -1.12874, -33.07116, 26.41262, -1.97993, 2.18783, 9.98759, -0.65995, -1.67186, -2.77506, -1.13478, 0.55207, 1.46473, 7.85896, -27.88344, -0.49174, -0.63390, -1.03154, -1.27153, -1.50385, -1.03338, -1.37297, -1.24249, -1.01223, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000
    ;
 var mig_7;
   periods   1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40;
   values 
   0.00000, -7.15887, -4.66240, -0.78066, 18.09781, -2.84580, -2.86701, -4.07665, -1.83719, -29.95771, 23.74113, -2.06770, 1.52421, 7.03263, -2.38895, -1.27214, -0.47813, -1.70066, -1.48186, -0.00872, -6.91440, -3.83517, -1.14986, -1.68676, -1.81912, -2.15968, -2.36959, -2.57839, -2.09323, -2.41634, -2.25203, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000
    ;
 var mig_8;
   periods   1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40;
   values 
   0.00000, -2.60426, 0.45447, 0.29363, 4.47123, -4.88060, -2.06141, -5.45104, -11.08725, -26.30093, 19.33591, -3.92108, -1.41162, 5.76041, -3.18770, -2.02474, -5.11767, -1.58849, -1.55938, -2.08710, -11.87921, 3.94876, -0.89594, -1.27302, -1.78485, -1.69341, -1.84974, -2.06545, -2.25593, -2.01368, -2.28012, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000
    ;
 var mig_9;
   periods   1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40;
   values 
   0.00000, -7.32663, -5.69791, -4.60798, -1.58880, -5.14256, -4.89261, -5.88742, -7.63637, -12.73230, 12.96525, -5.14093, -4.62624, 1.90117, -4.35970, -3.29023, -3.63924, -5.36828, -3.75042, -4.66005, -0.82582, 3.64852, -3.35947, -3.53419, -4.50745, -5.43281, -5.36615, -5.65224, -5.98608, -6.28785, -5.82621, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000
    ;
 var mig_10;
   periods   1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40;
   values 
   0.00000, -6.50695, -2.01053, -4.77744, 2.05942, -4.35450, -4.82296, -4.71955, -6.07575, -12.14463, 6.08468, -7.07058, -4.65454, -2.67858, -5.64211, -6.57506, -7.11855, -7.51838, -6.27690, -4.26099, -9.65595, -11.99399, -9.96624, -10.92731, -11.47658, -16.00337, -18.32031, -18.51584, -19.38024, -19.86565, -20.37584, -23.88915, -23.88915, -23.88915, -23.88915, -23.88915, -23.88915, -23.88915, -23.88915, -23.88915
    ;
 var mig_11;
   periods   1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40;
   values 
   0.00000, -3.10482, -3.06298, 0.12857, 0.12824, -2.81607, -3.62993, -3.65802, -5.83128, -9.16036, -0.13747, -4.37971, -4.77615, -3.71778, -6.20641, -6.83605, -6.49982, -8.84824, -10.02911, -9.19644, 19.14517, -9.55434, -14.74966, -18.06522, -19.15033, -19.89130, -28.42021, -32.36913, -32.89654, -34.43924, -35.14568, -35.83373, -35.83373, -35.83373, -35.83373, -35.83373, -35.83373, -35.83373, -35.83373, -35.83373
    ;
 var mig_12;
   periods   1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40;
   values 
   0.00000, -1.18237, -0.55946, -0.57988, -0.30144, -1.91352, -1.07383, -0.96231, -2.19504, -0.37606, 1.96424, -2.50780, -2.01773, -3.25295, -3.44719, -4.66729, -4.87699, -5.70372, -7.47590, -7.70835, -8.87156, -23.59060, -15.08954, -17.27365, -20.58647, -21.70923, -22.39949, -32.70847, -38.88168, -40.20912, -42.92945, -43.00048, -43.00048, -43.00048, -43.00048, -43.00048, -43.00048, -43.00048, -43.00048, -43.00048
    ;
 var mig_13;
   periods   1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40;
   values 
   0.00000, -0.24904, 0.36939, -0.03020, 0.89737, -0.05258, 0.97691, 0.82582, -0.79064, 1.91640, 2.59891, -0.21886, -0.74589, -0.52853, -1.52063, -1.18610, -2.45614, -2.49147, -2.57641, -3.75403, 1.61091, -5.94466, -3.64535, -10.30355, -12.66527, -16.22669, -18.14350, -19.56562, -30.65883, -39.21854, -43.00525, -43.00048, -43.00048, -43.00048, -43.00048, -43.00048, -43.00048, -43.00048, -43.00048, -43.00048
    ;
 var mig_14;
   periods   1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40;
   values 
   0.00000, -0.09224, 0.05853, -0.01721, 0.17678, -0.08802, 0.22551, 0.11965, -0.32864, 0.66812, 0.35029, 0.10822, 0.41804, 1.14080, 1.06218, 0.10325, -0.46579, -0.27589, -0.34888, -0.77560, 0.40718, -2.36428, -1.07490, -1.06429, -3.88082, -5.26331, -7.28056, -8.63937, -9.85953, -16.76413, -22.02646, -23.88915, -23.88915, -23.88915, -23.88915, -23.88915, -23.88915, -23.88915, -23.88915, -23.88915
    ;
 var mig_15;
   periods   1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40;
   values 
   0.00000, -0.01278, 0.00568, -0.00292, 0.00883, -0.00786, 0.02160, -0.00045, -0.02467, 0.08252, -0.00929, 0.03895, 0.05101, 0.15374, 0.10945, -0.15515, -0.08429, -0.01590, -0.01755, -0.01726, 0.10960, 1.05855, 0.06160, 0.00025, 0.08731, -0.36481, -0.34309, -0.54430, -0.67132, -0.83870, -1.77119, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000
    ;

   var beta1;        
   periods   1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 ;
   values   
0.9626 0.9638 0.9440 0.8764 0.9694 0.9719 0.9749 0.9774 0.9471 0.9795 0.9909 0.9924 0.9933 0.9938 0.9939 0.9946 0.9944 0.9946 0.9941 0.9954 0.9962 0.9967 0.9971 0.9974 0.9978 0.9980 0.9983 0.9985 0.9987 0.9988 0.9990 0.9991 0.9992 0.9993 0.9994 0.9995 0.9995 0.9996 0.9997 0.9997
  ;   
   var beta2;        
   periods   1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 ;
   values   
0.9593 0.9596 0.9524 0.8897 0.9674 0.9693 0.9720 0.9733 0.9548 0.9811 0.9882 0.9903 0.9911 0.9915 0.9922 0.9930 0.9933 0.9932 0.9927 0.9939 0.9950 0.9955 0.9961 0.9965 0.9969 0.9973 0.9976 0.9979 0.9981 0.9983 0.9985 0.9987 0.9989 0.9990 0.9991 0.9992 0.9993 0.9994 0.9994 0.9995
  ;   
   var beta3;        
   periods   1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 ;
   values   
0.9528 0.9541 0.9518 0.9193 0.9624 0.9641 0.9665 0.9672 0.9550 0.9786 0.9842 0.9862 0.9874 0.9873 0.9880 0.9894 0.9901 0.9907 0.9904 0.9913 0.9925 0.9933 0.9940 0.9946 0.9952 0.9957 0.9962 0.9966 0.9970 0.9973 0.9976 0.9978 0.9981 0.9983 0.9985 0.9986 0.9988 0.9989 0.9990 0.9991
  ;   
   var beta4;        
   periods   1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 ;
   values   
0.9455 0.9440 0.9481 0.9326 0.9556 0.9551 0.9583 0.9590 0.9512 0.9719 0.9761 0.9798 0.9810 0.9811 0.9813 0.9824 0.9845 0.9858 0.9863 0.9869 0.9885 0.9897 0.9908 0.9918 0.9927 0.9935 0.9942 0.9948 0.9953 0.9958 0.9963 0.9967 0.9970 0.9974 0.9976 0.9979 0.9981 0.9983 0.9985 0.9987
  ;   
   var beta5;        
   periods   1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 ;
   values   
0.9339 0.9315 0.9357 0.9300 0.9433 0.9429 0.9449 0.9460 0.9425 0.9610 0.9634 0.9678 0.9712 0.9708 0.9724 0.9723 0.9750 0.9782 0.9799 0.9811 0.9831 0.9849 0.9865 0.9879 0.9892 0.9904 0.9914 0.9923 0.9931 0.9939 0.9945 0.9951 0.9956 0.9961 0.9965 0.9969 0.9972 0.9975 0.9978 0.9980
  ;   
   var beta6;        
   periods   1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 ;
   values   
0.9143 0.9126 0.9162 0.9146 0.9244 0.9239 0.9271 0.9273 0.9251 0.9469 0.9468 0.9507 0.9544 0.9572 0.9587 0.9609 0.9624 0.9663 0.9710 0.9733 0.9760 0.9787 0.9811 0.9832 0.9850 0.9867 0.9882 0.9895 0.9907 0.9917 0.9926 0.9934 0.9942 0.9948 0.9954 0.9959 0.9964 0.9968 0.9971 0.9975
  ;   
   var beta7;        
   periods   1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 ;
   values   
0.8832 0.8799 0.8872 0.8853 0.8939 0.8949 0.8979 0.8996 0.8963 0.9230 0.9258 0.9285 0.9312 0.9334 0.9408 0.9434 0.9479 0.9512 0.9571 0.9617 0.9657 0.9693 0.9725 0.9754 0.9780 0.9803 0.9823 0.9842 0.9858 0.9873 0.9887 0.9898 0.9909 0.9919 0.9927 0.9935 0.9942 0.9948 0.9953 0.9958
  ;   
   var beta8;        
   periods   1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 ;
   values   
0.8317 0.8252 0.8371 0.8361 0.8488 0.8459 0.8552 0.8554 0.8499 0.8848 0.8905 0.8980 0.8991 0.8999 0.9090 0.9190 0.9249 0.9319 0.9375 0.9428 0.9480 0.9525 0.9566 0.9604 0.9638 0.9669 0.9698 0.9724 0.9748 0.9770 0.9790 0.9808 0.9825 0.9840 0.9854 0.9867 0.9878 0.9889 0.9899 0.9907
  ;   
   var beta9;        
   periods   1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 ;
   values   
0.7513 0.7473 0.7570 0.7559 0.7768 0.7737 0.7839 0.7873 0.7750 0.8216 0.8317 0.8443 0.8531 0.8508 0.8614 0.8747 0.8898 0.8998 0.9108 0.9148 0.9224 0.9291 0.9352 0.9409 0.9460 0.9507 0.9550 0.9589 0.9625 0.9658 0.9688 0.9715 0.9740 0.9763 0.9784 0.9803 0.9820 0.9836 0.9850 0.9863
  ;   
   var beta10;        
   periods   1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 ;
   values   
0.6344 0.6250 0.6420 0.6356 0.6652 0.6612 0.6798 0.6831 0.6642 0.7236 0.7350 0.7558 0.7716 0.7795 0.7884 0.8046 0.8232 0.8463 0.8625 0.8719 0.8843 0.8959 0.9063 0.9158 0.9243 0.9320 0.9390 0.9452 0.9508 0.9559 0.9604 0.9645 0.9681 0.9714 0.9744 0.9770 0.9794 0.9815 0.9834 0.9851
  ;   
   var beta11;        
   periods   1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 ;
   values   
0.4863 0.4781 0.4879 0.4905 0.5196 0.5092 0.5393 0.5405 0.5007 0.5854 0.5963 0.6231 0.6437 0.6641 0.6810 0.6963 0.7183 0.7475 0.7804 0.7945 0.8146 0.8333 0.8503 0.8656 0.8795 0.8920 0.9032 0.9134 0.9225 0.9306 0.9380 0.9446 0.9504 0.9557 0.9605 0.9647 0.9685 0.9718 0.9749 0.9776
  ;   
   var beta12;        
   periods   1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 ;
   values   
0.3243 0.3238 0.3460 0.3272 0.3688 0.3429 0.3792 0.3802 0.3342 0.4211 0.4283 0.4572 0.4809 0.5042 0.5280 0.5521 0.5657 0.6032 0.6402 0.6655 0.6905 0.7141 0.7361 0.7567 0.7758 0.7936 0.8101 0.8253 0.8394 0.8524 0.8644 0.8755 0.8857 0.8951 0.9037 0.9116 0.9189 0.9256 0.9318 0.9374
  ;   
   var beta13;        
   periods   1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 ;
   values   
0.2011 0.1936 0.2036 0.1918 0.2284 0.2047 0.2306 0.2396 0.1946 0.2686 0.2705 0.2892 0.3116 0.3332 0.3576 0.3775 0.3940 0.4217 0.4635 0.4798 0.5024 0.5242 0.5453 0.5657 0.5855 0.6046 0.6231 0.6408 0.6579 0.6743 0.6900 0.7051 0.7195 0.7333 0.7465 0.7591 0.7712 0.7827 0.7936 0.8040
  ;   
   var beta14;        
   periods   1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 ;
   values   
0.1213 0.1051 0.1098 0.1065 0.1225 0.1063 0.1265 0.1287 0.0912 0.1532 0.1487 0.1623 0.1773 0.1928 0.2063 0.2231 0.2267 0.2564 0.2795 0.2822 0.2928 0.3052 0.3175 0.3298 0.3420 0.3541 0.3662 0.3781 0.3899 0.4016 0.4132 0.4246 0.4359 0.4470 0.4580 0.4688 0.4794 0.4899 0.5002 0.5104
  ;   
   var beta15;        
   periods   1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 ;
   values   
0.0641 0.0472 0.0535 0.0490 0.0493 0.0427 0.0584 0.0500 0.0350 0.0835 0.0589 0.0784 0.0871 0.1039 0.1037 0.1149 0.1197 0.1368 0.1484 0.1429 0.1439 0.1482 0.1524 0.1567 0.1610 0.1654 0.1698 0.1742 0.1787 0.1831 0.1877 0.1922 0.1967 0.2013 0.2059 0.2105 0.2151 0.2198 0.2245 0.2291
  ;   
end;

//***************************************


//***************************************
options_.maxit_=15
 simul;


//***************************************
// FIGURES
//***************************************
// vector with names of variables saved in  M_.endo_names
// final steady state given saved in oo_.steady_state
// simulated endogenous variables are saved in oo_.endo_simul
// yy_fss defined as final steady state, while y_iss is initial steady state (see above command)
   
yy_fss =oo_.steady_state;
// Yearly Interest Rate
//.........................................................................................................
// Rdev=100*((R.^(1/5)-1)-(oo_.endo_simul(62, 22)^(1/5)-1));
   Rdev=100*(R.^(1/5)-1);

// Financial Wealth  per capita 
//.........................................................................................................
  FWpc=st./PTot;

// Cons. per capita 
//.........................................................................................................
   ctdev=100*((ct./PTot)/(oo_.endo_simul(73, 65)/oo_.endo_simul(17, 65)));
   cpc=ct./PTot;
   cpg=ct./gdp;
// cpgdev=ct./gdp-oo_.endo_simul(73, 22)/oo_.endo_simul(69, 22);

// Labour Productivity
//.........................................................................................................
   ydev=100*((gdp./N)/(oo_.endo_simul(69, 65)/oo_.endo_simul(18, 65)));
   ypw=gdp./N;

// Gross Wage
//.........................................................................................................
   wdev=100*((wt./N)/(oo_.endo_simul(81, 22)./oo_.endo_simul(18, 22))-1);

// Employment Rate
//.........................................................................................................
     ERdev=100*(N./PATot);

// Unemployment rates
//.........................................................................................................
   u0=0*N; urdev_25=0*N;            
   u4=0*N; urdev_45=0*N;            
   URate=0*N;       

// Activity Rates
//.........................................................................................................
   A6dev=100*(1-i6);
   A7dev=100*(1-i7);
   ARate=100*((1-i6).*P6+(1-i7).*P7)./(P6+P7);

// Cost of public pensions and taxes
//.........................................................................................................
// tauc_dev=100*tauc;
   PPCost=100*((dl+de)./gdp);
   SSCost=100*(de+dl)./gdp;
   DRdev=100*DR;
  

 year=[1895:5:2350]';
 figure(1);
  subplot(3,2,1);plot(year(22:42),Rdev(22:42));title('Yearly Interest Rate');
  subplot(3,2,2);plot(year(22:42),wdev(22:42));title('Wage (% change since 2000)');
  subplot(3,2,3);plot(year(22:42),ARate(22:42));title('Activity rate 55-64');
  subplot(3,2,4);plot(year(22:42),URate(22:42));title('Average Unemployment rate (< 55)');
  subplot(3,2,5);plot(year(22:42),PPCost(22:42));title('Cost of Public Pensions (% of GDP)');
  subplot(3,2,6);plot(year(22:42),cpg(22:42));title('Consumption (% of GDP)');


format short e;
 MAT_CE_PC=[  year, Rdev, wdev, ARate URate, PPCost, cpg, cpc ];







